from datetime import datetime


class LatexTools:
    @staticmethod
    def escape_underscore(string: str) -> str:
        double_backslash = "\\"
        return string.replace("_", f"{double_backslash}_")

    @staticmethod
    def get_latex_figure_start(caption: str, label: str) -> str:
        double_backslash = "\\"
        # The indentation here is intended
        return f"""% Figure generated by gpufi-4_l1i_injection_campaigns on {datetime.now().isoformat()}
{double_backslash}begin{{figure}}[ht]
    {double_backslash}caption{{{LatexTools.escape_underscore(caption)}}}
    {double_backslash}label{{{label}}}"""

    @staticmethod
    def get_latex_figure_end():
        double_backslash = "\\"
        # The indentation here is intended
        return f"""
{double_backslash}end{{figure}}"""

    @staticmethod
    def get_latex_vertical_space():
        double_backslash = "\\"
        # The indentation here is intended
        return f"""
    {double_backslash}{double_backslash}[3ex]"""

    @staticmethod
    def get_latex_table_start(caption: str, label: str) -> str:
        double_backslash = "\\"
        # The indentation here is intended
        return f"""% Table generated by gpufi-4_l1i_injection_campaigns on {datetime.now().isoformat()}
{double_backslash}begin{{table}}[!ht]
    {double_backslash}caption{{{LatexTools.escape_underscore(caption)}}}
    {double_backslash}label{{{label}}}
    {double_backslash}begin{{center}}"""

    @staticmethod
    def get_latex_table_end():
        double_backslash = "\\"
        # The indentation here is intended
        return f"""
    {double_backslash}end{{center}}
{double_backslash}end{{table}}"""

    @staticmethod
    def get_latex_tabular_start(alignment: str, resize: bool = True) -> str:
        double_backslash = "\\"
        # The indentation here is intended
        latex = ""
        if resize:
            latex = f"""{double_backslash}resizebox{{{double_backslash}textwidth}}{{!}}{{
"""
        latex += f"""{double_backslash}begin{{tabular}}{{{alignment}}}
"""
        return latex

    @staticmethod
    def get_latex_tabular_end(resize: bool = False):
        double_backslash = "\\"
        # The indentation here is intended
        latex = f"""{double_backslash}end{{tabular}}
"""
        if resize:
            latex += """}
"""
        return latex

    @staticmethod
    def to_latex_subfigure(caption: str, label: str, filename: str) -> str:
        double_backslash = "\\"

        # The indentation here is intended
        return f"""
    {double_backslash}begin{{subfigure}}[b]{{0.45{double_backslash}textwidth}}
        {double_backslash}centering
        {double_backslash}caption{{{LatexTools.escape_underscore(caption)}.}}
        {double_backslash}label{{{label}}}
        {double_backslash}includegraphics[page=1,width={double_backslash}textwidth]{{{filename}}}
    {double_backslash}end{{subfigure}}"""

    @staticmethod
    def get_latex_figure(filename: str) -> str:
        double_backslash = "\\"

        # The indentation here is intended
        return f"""
        {double_backslash}centering
        {double_backslash}includegraphics[page=1,width={double_backslash}textwidth]{{{filename}}}"""
